global gStates, gObjects, gCursorlist, gKeyRef, gUNVobjects, sBGpict, gTimerList, gSoundchannels, gCurKeyRef, sQTSPRITE

on EnterB02
  if getaProp(getaProp(gStates, #Conditions), #Trailer) = #true then
    PDARelease("J04m01p.mov")
    PDARelease("J05weath.mov")
  end if
end

on EnterB09
  if (getaProp(getaProp(gStates, #BeenThere), #B19A) + getaProp(getaProp(gStates, #BeenThere), #B19B)) > 1 then
    PDARelease("J04m10c.mov")
  end if
end

on doGetLeaf2
  ReleaseUNVobject(#leaf1Obj)
  genexitkf(#B16B)
end

on enterB21
  set OBj to getaProp(gObjects, #ButterFlySeen)
  if (getaProp(getaProp(gStates, #Conditions), #Trailer) = #true) and (getaProp(OBj, #State) = #Trailer) then
    MakeDynamic(#ButterFlySeen, #State, #Butter)
    Startthetimer(1, "StartMillSounds")
  else
    if getaProp(OBj, #State) = #seen then
      playSound("B21mill.aif", #keyframeCast)
    else
      if getaProp(getaProp(gStates, #Conditions), #Trailer) <> #true then
        playSound("B21wind.aif", #keyframeCast)
      end if
    end if
  end if
end

on StartMillSounds
  playSound("B21wind.aif", #keyframeCast)
  set animObj to getaProp(getaProp(gObjects, #ButterAnim), #animator)
  repeat while the pCurrentFrame of animObj < 30
    CursorandUpdate()
  end repeat
  stopsound("B21wind.aif")
  set startSoundChannel to playSound("B21start.aif", #keyframeCast)
  repeat while soundBusy(startSoundChannel)
    CursorandUpdate()
  end repeat
  stopsound("B21start.aif")
  playSound("B21mill.aif", #keyframeCast)
end

on DoBdoortoC
  set OBj to getaProp(gObjects, #ButterFlySeen)
  if (getaProp(getaProp(gStates, #Conditions), #Trailer) = #true) and (getaProp(OBj, #State) = #seen) then
    genexitkf(#C01)
  else
    playSound("B31FXno.aif", #keyframeCast)
  end if
end

on DoSail
  if gKeyRef = #B10A then
    PDARelease("J04m05c.mov")
  else
    if gKeyRef = #B10B then
      PDARelease("J04m16p.mov")
    end if
  end if
  genexitkf(#B10B)
  setaProp(gStates, #redHerring, 1)
end

on ExitB16A
  if getaProp(getaProp(gObjects, #BBGasSwitch), #State) = #open then
    do(string(getaProp(getaProp(getaProp(gObjects, #BBGasSwitch), #Action), #down) && "#BBGasSwitch"))
  end if
  if getaProp(getaProp(gObjects, #BBvalve), #State) = #open then
    do(string(getaProp(getaProp(getaProp(gObjects, #BBvalve), #Action), #down) && "#BBvalve"))
  end if
end

on setupBalloon
  givePDA()
  set the State of the ButterFlySeen of gObjects to #seen
  Jumptokey(#b16a)
end

on DoHoseAttach
  set HOBJ to getaProp(gObjects, #BBHose)
  set VOBJ to getaProp(gObjects, #BBvalve)
  set FOBJ to getaProp(gObjects, #BBGasSwitch)
  set GOBJ to getaProp(gObjects, #BBgage)
  if getaProp(HOBJ, #State) = #open then
    MakeDynamic(#BBHose, #Hotrect, getaProp(getaProp(gObjects, #BBHose), #AttachHOTRECT))
    MakeDynamic(#BBHose, #DisplayState, #Attach)
    set SpriteNum to getaProp(HOBJ, #SpriteNum)
    deleteProp(gHotRects, value(string(SpriteNum) & "01"))
    deleteProp(gHotRects, value(string(SpriteNum) & "02"))
    if getaProp(VOBJ, #State) = #open then
      playSound("B16FXhs.aif", #keyframeCast)
    end if
    setHoseHotRects()
    if (getaProp(VOBJ, #State) = #open) and (getaProp(FOBJ, #State) = #open) and (getaProp(getaProp(gObjects, #ButterFlySeen), #State) = #seen) then
      BallonFillTank()
    end if
  else
    if getaProp(HOBJ, #State) = #close then
      MakeDynamic(#BBHose, #Hotrect, getaProp(getaProp(gObjects, #BBHose), #DetachHOTRECT))
      MakeDynamic(#BBHose, #DisplayState, #Detach)
      set SpriteNum to getaProp(HOBJ, #SpriteNum)
      deleteProp(gHotRects, value(string(SpriteNum) & "01"))
      deleteProp(gHotRects, value(string(SpriteNum) & "02"))
      setHoseHotRects()
      if getaProp(VOBJ, #State) = #open then
        playSound("B16FXhs.aif", #keyframeCast)
      end if
      BallonTurnOffGas()
      if getaProp(getaProp(gObjects, #BBGasSwitch), #State) = #open then
        DrainTank()
      end if
    end if
  end if
end

on setHoseHotRects
  set HoseOBJ to getaProp(gObjects, #BBHose)
  set nRects to count(getaProp(HoseOBJ, #Hotrect))
  repeat with X = 1 to nRects
    set hotrectlist to [#rect: getAt(getaProp(HoseOBJ, #Hotrect), X), #RefName: getaProp(HoseOBJ, #RefName)]
    setaProp(gHotRects, value(getaProp(HoseOBJ, #SpriteNum) & 0 & X), hotrectlist)
  end repeat
end

on DoBBvalve
  set HOBJ to getaProp(gObjects, #BBHose)
  set VOBJ to getaProp(gObjects, #BBvalve)
  set FOBJ to getaProp(gObjects, #BBGasSwitch)
  set GOBJ to getaProp(gObjects, #BBgage)
  if getaProp(getaProp(gObjects, #ButterFlySeen), #State) = #seen then
    if getaProp(VOBJ, #State) = #open then
      playSound("B16fxfil.aif", #keyframeCast)
      if (getaProp(HOBJ, #State) = #open) and (getaProp(FOBJ, #State) = #open) then
        BallonFillTank()
      end if
    else
      if getaProp(VOBJ, #State) = #close then
        stopsound("B16fxfil.aif")
        BallonTurnOffGas()
      end if
    end if
  end if
end

on DoBBGasSwitch
  set HOBJ to getaProp(gObjects, #BBHose)
  set VOBJ to getaProp(gObjects, #BBvalve)
  set FOBJ to getaProp(gObjects, #BBGasSwitch)
  set GOBJ to getaProp(gObjects, #BBgage)
  if (getaProp(FOBJ, #State) = #open) and (getaProp(getaProp(gObjects, #ButterFlySeen), #State) = #seen) then
    playSound("B16fxvlv.aif", #keyframeCast)
  else
    stopsound("B16fxvlv.aif")
  end if
  if (getaProp(FOBJ, #State) = #open) and (getaProp(HOBJ, #State) = #open) and (getaProp(VOBJ, #State) = #open) and (getaProp(getaProp(gObjects, #ButterFlySeen), #State) = #seen) then
    BallonFillTank()
  else
    if (getaProp(FOBJ, #State) = #open) and (getaProp(HOBJ, #State) = #close) then
      BallonTurnOffGas()
      DrainTank()
    else
      if getaProp(FOBJ, #State) = #close then
        BallonTurnOffGas()
      end if
    end if
  end if
end

on BallonFillTank
  playSound("B16FXhss.aif", #keyframeCast)
  MakeDynamic(#BBgage, #State, #on)
  Startthetimer(30, "MoveBallonGage", #BBvalve)
end

on BallonTurnOffGas
  set HOBJ to getaProp(gObjects, #BBHose)
  set VOBJ to getaProp(gObjects, #BBvalve)
  set GOBJ to getaProp(gObjects, #BBgage)
  MakeDynamic(#BBgage, #State, #off)
  if not voidp(getaProp(VOBJ, #timer)) then
    set howmany to count(getaProp(VOBJ, #timer))
    repeat with thisTimer = 1 to howmany
      set killtimer to getAt(getaProp(VOBJ, #timer), 1)
      DeletetheTimer(killtimer)
    end repeat
  end if
end

on MoveBallonGage
  set BOBJ to getaProp(gObjects, #BBallon)
  set GOBJ to getaProp(gObjects, #BBgage)
  if getaProp(GOBJ, #State) = #off then
    exit
  end if
  if getaProp(GOBJ, #DisplayState) = #FULL then
    if getaProp(BOBJ, #Explode) = #false then
      setaProp(BOBJ, #explodeTimer, the ticks)
    end if
    MakeDynamic(#BBallon, #Explode, #Pending)
    if the ticks > (getaProp(BOBJ, #explodeTimer) + 300) then
      BallonBlowUp()
    end if
    if (getaProp(BOBJ, #Launch) = #false) and (getaProp(BOBJ, #Explode) <> #true) then
      Startthetimer(30, "MoveBallonGage", #BBvalve)
    end if
  else
    if getaProp(GOBJ, #DisplayState) = 20 then
      playSound("B16wng.aif", #keyframeCast)
      MakeDynamic(#BBgage, #DisplayState, #FULL)
      Startthetimer(30, "MoveBallonGage", #BBvalve)
      set the castNum of sprite getaProp(GOBJ, #SpriteNum) to getaProp(getaProp(GOBJ, #cast), #FULL)
    else
      MakeDynamic(#BBgage, #DisplayState, getaProp(GOBJ, #DisplayState) + 1)
      Startthetimer(30, "MoveBallonGage", #BBvalve)
      set the castNum of sprite getaProp(GOBJ, #SpriteNum) to getaProp(getaProp(GOBJ, #cast), getaProp(GOBJ, #DisplayState))
    end if
  end if
end

on DrainTank
  set GOBJ to getaProp(gObjects, #BBgage)
  playSound("B16fxvlv.aif", #keyframeCast)
  if getaProp(GOBJ, #DisplayState) = #FULL then
    MakeDynamic(#BBgage, #DisplayState, 20)
    set the castNum of sprite getaProp(GOBJ, #SpriteNum) to getaProp(getaProp(GOBJ, #cast), 20)
    CursorandUpdate()
  end if
  repeat while getaProp(GOBJ, #DisplayState) <> 1
    MakeDynamic(#BBgage, #DisplayState, getaProp(GOBJ, #DisplayState) - 1)
    set the castNum of sprite getaProp(GOBJ, #SpriteNum) to getaProp(getaProp(GOBJ, #cast), getaProp(GOBJ, #DisplayState))
    CursorandUpdate()
  end repeat
  stopsound("B16fxvlv.aif")
end

on BallonFillGasAir
  Startthetimer(the maxinteger / 2, "Nothing", #BBvalve)
end

on BallonBlowUp
  set BOBJ to getaProp(gObjects, #BBallon)
  MakeDynamic(#BBallon, #Explode, #true)
  set explosionChannel to playSound("B16expl.aif", #keyframeCast)
  DelObjects([#BallonControls])
  set the castNum of sprite 1 to the number of cast "cNullSprite"
  stopsound("B16fxfil.aif")
  repeat while soundBusy(explosionChannel)
    CursorandUpdate()
  end repeat
  genexitkf(#BDIE)
end

on DoBBFlint
  set BOBJ to getaProp(gObjects, #BBallon)
  set HOBJ to getaProp(gObjects, #BBHose)
  set VOBJ to getaProp(gObjects, #BBvalve)
  set FOBJ to getaProp(gObjects, #BBGasSwitch)
  set GOBJ to getaProp(gObjects, #BBgage)
  if (getaProp(GOBJ, #DisplayState) >= 19) or ((getaProp(GOBJ, #DisplayState) = #FULL) and (getaProp(FOBJ, #State) = #open) and (getaProp(getaProp(gObjects, #ButterFlySeen), #State) = #seen)) then
    MakeDynamic(#bbflint, #Hotrect, [rect(0, 0, 0, 0)])
    set gasSoundChannel to playSound("B16FXgas.aif", #keyframeCast)
    Startthetimer(90, "LightFlame")
    if getaProp(BOBJ, #Explode) <> #true then
      Startthetimer(160, "BBLaunchBallon", #BBallon)
      MakeDynamic(#BBallon, #Launch, #true)
    end if
  else
    playSound("B16sprk2.aif", #keyframeCast)
  end if
end

on LightFlame
  ChangeSpecialState(#bbflint, #Flame)
end

on BBLaunchBallon
  set HOBJ to getaProp(gObjects, #BBHose)
  if getaProp(HOBJ, #State) = #open then
    OpenClose(#BBHose)
  end if
  MakeDynamic(#BBallon, #solved, #true)
  genexitkf(#B13B)
end

on exitB31B
  doResetPINScreen(#enterWndSpd)
end

on EnterB31AD
  set RegObj to getaProp(gObjects, #WaterRegulator)
  set BridgeObj to getaProp(gObjects, #ChaoticBridge)
  set BridgeAnimProps to getaProp(BridgeObj, #AnimProps)
  if getaProp(RegObj, #State) <> #StationaryOpen then
    MakeDynamic(#ChaoticBridgeParent, #State, #Chaotic)
    if getaProp(RegObj, #State) = #RightLOW then
      setaProp(BridgeAnimProps, #frameRate, 3)
    else
      setaProp(BridgeAnimProps, #frameRate, 10)
    end if
    MakeDynamic(#ChaoticBridge, #AnimProps, BridgeAnimProps)
  else
    MakeDynamic(#ChaoticBridgeParent, #State, #StationaryOpen)
  end if
end

on DoLaunchBT
  set BOBJ to getProp(gObjects, #BBallon)
  set panelObj to getaProp(gObjects, #LaunchPanel)
  set currentPIN to getaProp(panelObj, #BRocketText)
  if getaProp(getaProp(gObjects, #ButterFlySeen), #State) = #seen then
    if (getaProp(BOBJ, #solved) = #true) and (currentPIN = 10) then
      switchFeedback(#relayingData)
      MakeDynamic(#BRocket, #solved, #true)
      genexitkf(#B31C)
      Startthetimer(300, "SetUpRocketPDARelease")
    else
      if (getaProp(BOBJ, #solved) = #true) and (currentPIN <> 10) then
        playSound("B31FXno.aif", #keyframeCast)
        setRcktPINKeyState(#off)
        switchFeedback(#incorrectWndSpd)
        Startthetimer(120, "doResetPINScreen #incorrectWndSpd")
        PDARelease("J04m07c.mov")
      else
        if getaProp(BOBJ, #solved) = #false then
          playSound("B31bnt.aif", #keyframeCast)
          setRcktPINKeyState(#off)
          switchFeedback(#probeNotTrcked)
          Startthetimer(120, "doResetPINScreen #probeNotTrcked")
          PDARelease("J04m07c.mov")
        end if
      end if
    end if
  end if
end

on SetUpRocketPDARelease
  Startthetimer(the stopTime of sprite sQTSPRITE - the movieTime of sprite sQTSPRITE + 30, "doRocketPDARelease")
end

on doRocketPDARelease
  PDARelease("J04m04p.mov")
end

on LaunchPad KeyNum
  if getaProp(getaProp(gObjects, #ButterFlySeen), #State) = #seen then
    set LOBJ to getProp(gObjects, #LaunchBT)
    set panelObj to getaProp(gObjects, #LaunchPanel)
    set currentPIN to getaProp(panelObj, #BRocketText)
    if integerp(KeyNum) then
      if getaProp(panelObj, #State) = #on then
        put string(KeyNum) after currentPIN
        set curPosition to the number of chars in currentPIN
        if curPosition = 3 then
          setRcktPINKeyState(#off)
        end if
        set PINDispObj to getaProp(gObjects, value("#rcktPINDisp" & curPosition))
        set PINDispSprtNum to getaProp(PINDispObj, #SpriteNum)
        set wchCst to value("#PD" & KeyNum)
        set the castNum of sprite PINDispSprtNum to getAt(getaProp(getaProp(PINDispObj, #cast), wchCst), 1)
        MakeDynamic(getaProp(PINDispObj, #RefName), #DisplayState, wchCst)
      end if
    else
      if KeyNum = #Cancel then
        if currentPIN <> EMPTY then
          setRcktPINKeyState(#on)
          set curPosition to the number of chars in currentPIN
          delete char -30000 of currentPIN
          set PINDispObj to getaProp(gObjects, value("#rcktPINDisp" & curPosition))
          set PINDispSprtNum to getaProp(PINDispObj, #SpriteNum)
          set the castNum of sprite PINDispSprtNum to getAt(getaProp(getaProp(PINDispObj, #cast), #blank), 1)
        end if
      end if
    end if
    MakeDynamic(#LaunchPanel, #BRocketText, currentPIN)
  end if
end

on setRcktPINKeyState setState
  if symbolp(setState) then
    MakeDynamic(#LaunchPanel, #State, setState)
  else
    alert("bad parameter passed to setShortKeyBoardState")
  end if
end

on doResetPINScreen whichState
  if getaProp(getaProp(gObjects, #ButterFlySeen), #State) = #seen then
    repeat with X = 1 to 3
      set PINDispObj to getaProp(gObjects, value("#rcktPINDisp" & X))
      set PDSprtNum to getaProp(PINDispObj, #SpriteNum)
      set the castNum of sprite PDSprtNum to getAt(getaProp(getaProp(PINDispObj, #cast), #blank), 1)
      setaProp(PINDispObj, #DisplayState, #blank)
    end repeat
    setRcktPINKeyState(#on)
    MakeDynamic(#LaunchPanel, #BRocketText, EMPTY)
    switchFeedback(whichState)
  end if
end

on switchFeedback newState
  set displayObj to getaProp(gObjects, #rcktScreenInfo)
  MakeDynamic(#rcktScreenInfo, #DisplayState, newState)
  MakeDynamic(#rcktScreenInfo, #State, newState)
  set displaySprtNum to getaProp(displayObj, #SpriteNum)
  set the castNum of sprite displaySprtNum to the number of cast getaProp(getaProp(displayObj, #cast), newState)
end

on EnterB28
  set RegObjState to getaProp(getaProp(gObjects, #WaterRegulator), #State)
  if (RegObjState = #StationaryClose) or (RegObjState = #RightLOW) then
    playSound("B28FXtrl.aif", #keyframeCast)
  else
    if (RegObjState = #LeftHi) or (RegObjState = #RightHi) then
      playSound("B28FXgh1.aif", #keyframeCast)
    end if
  end if
end

on DoBridgeValve
  set VOBJ to getaProp(gObjects, #BridgeValve)
  set BOBJ to getaProp(gObjects, #BridgeLeveler)
  DoDisplayWaterFlow()
  MakeDynamic(#BridgeValve, #DisplayState, getaProp(VOBJ, #State))
end

on DoBridgeLeveler
  set VOBJ to getaProp(gObjects, #BridgeValve)
  set BOBJ to getaProp(gObjects, #BridgeLeveler)
  set Child to getaProp(gObjects, #WaterONOFF)
  set the castNum of sprite getaProp(Child, #SpriteNum) to getaProp(getaProp(Child, #cast), getaProp(BOBJ, #State))
  DoDisplayWaterFlow()
  MakeDynamic(#WaterONOFF, #DisplayState, getaProp(BOBJ, #State))
  MakeDynamic(#BridgeLeveler, #DisplayState, getaProp(BOBJ, #State))
  MakeDynamic(#BridgeValve, #DisplayState, getaProp(VOBJ, #State))
end

on playWaterSound inSound
  if inSound <> 0 then
    if inSound = "B28FXtrl.aif" then
      stopsound("B28FXgh1.aif")
      playSound("B28FXtrl.aif", #keyframeCast)
    else
      if inSound = "B28FXgh1.aif" then
        stopsound("B28FXtrl.aif")
        playSound("B28FXgh1.aif", #keyframeCast)
      end if
    end if
  else
    if inSound = 0 then
      stopsound("B28FXtrl.aif")
      stopsound("B28FXgh1.aif")
    end if
  end if
end

on DoDisplayWaterFlow
  set VOBJ to getaProp(gObjects, #BridgeValve)
  set BOBJ to getaProp(gObjects, #BridgeLeveler)
  set RegObj to getaProp(gObjects, #WaterRegulator)
  set aState to getaProp(getaProp(gObjects, #BBridge), #State)
  DelObjects(getaProp(getaProp(RegObj, #SpecialChild), getaProp(RegObj, #State)))
  if getaProp(VOBJ, #State) = #off then
    set asound to 0
    if getaProp(BOBJ, #State) = #right then
      if getaProp(RegObj, #State) <> #stationary then
        MakeDynamic(#WaterRegulator, #State, #RIGHTOff)
        MakeDynamic(#BBridge, #State, #close)
      end if
    else
      if getaProp(BOBJ, #State) = #left then
        if getaProp(RegObj, #State) <> #stationary then
          MakeDynamic(#WaterRegulator, #State, #LeftOff)
          MakeDynamic(#BBridge, #State, #close)
        end if
      end if
    end if
  else
    if getaProp(VOBJ, #State) = #LOW then
      set asound to "B28FXtrl.aif"
      if getaProp(BOBJ, #State) = #right then
        MakeDynamic(#WaterRegulator, #State, #RightLOW)
        MakeDynamic(#BBridge, #State, #close)
      else
        if getaProp(BOBJ, #State) = #left then
          MakeDynamic(#WaterRegulator, #State, #LeftLOW)
          MakeDynamic(#BBridge, #State, #open)
        end if
      end if
    else
      if getaProp(VOBJ, #State) = #HI then
        set asound to "B28FXgh1.aif"
        if getaProp(BOBJ, #State) = #right then
          MakeDynamic(#WaterRegulator, #State, #RightHi)
          MakeDynamic(#BBridge, #State, #close)
        else
          if getaProp(BOBJ, #State) = #left then
            MakeDynamic(#WaterRegulator, #State, #LeftHi)
            MakeDynamic(#BBridge, #State, #close)
          end if
        end if
      end if
    end if
  end if
  if getaProp(getaProp(gObjects, #BBridge), #State) <> aState then
    if getaProp(getaProp(gObjects, #BBridge), #State) = #close then
      if getaProp(getaProp(gObjects, #BRocket), #solved) = #false then
        setKFGlobals(#B28A)
        set the castNum of sprite 1 to the number of cast "B28A.PCT"
      else
        setKFGlobals(#B28D)
        set the castNum of sprite 1 to the number of cast "B28D.PCT"
      end if
    else
      if getaProp(getaProp(gObjects, #BRocket), #solved) = #false then
        setKFGlobals(#B28B)
        set the castNum of sprite 1 to the number of cast "B28B.PCT"
      else
        setKFGlobals(#B28C)
        set the castNum of sprite 1 to the number of cast "B28C.PCT"
      end if
    end if
  end if
  playWaterSound(asound)
  AddObjects(getaProp(getaProp(RegObj, #SpecialChild), getaProp(RegObj, #State)))
  if getaProp(RegObj, #State) = #LeftLOW then
    set animObj to getaProp(getaProp(gObjects, #BridgSwingClose), #animator)
    repeat while the pCurrentFrame of animObj < 6
      CursorandUpdate()
    end repeat
    DelObjects(getaProp(getaProp(RegObj, #SpecialChild), getaProp(RegObj, #State)))
    MakeDynamic(#WaterRegulator, #State, #StationaryClose)
    MakeDynamic(#BridgStationary, #DisplayState, #close)
    AddObjects(getaProp(getaProp(RegObj, #SpecialChild), getaProp(RegObj, #State)))
  end if
  if getaProp(VOBJ, #State) = #off then
    DelObjects(getaProp(getaProp(RegObj, #SpecialChild), getaProp(RegObj, #State)))
    MakeDynamic(#WaterRegulator, #State, #StationaryOpen)
    MakeDynamic(#BridgStationary, #DisplayState, #open)
  end if
end

on ButterAnimComplete
  AddObjects([#ButterAnimFlap])
  DelObjects([#ButterAnim])
  MakeDynamic(#ButterFlySeen, #State, #seen)
  setRcktPINKeyState(#on)
  switchFeedback(#enterWndSpd)
end

on calcTransToB11 Test
  global gKeyRef
  if Test = #Debug then
    return [#B11]
  end if
  if getaProp(getaProp(gObjects, #BBallon), #solved) = #true then
    set gKeyRef to #B12B
  else
    if getaProp(getaProp(gObjects, #BBallon), #solved) = #false then
      set gKeyRef to #B12A
    end if
  end if
  return #B11
end

on calcTransToB04 Test
  if Test = #Debug then
    return [#B04A, #B04B]
  end if
  if (getaProp(gCurKeyList, #RefName) = #B12A) or (getaProp(gCurKeyList, #RefName) = #B12B) then
    set gKeyRef to #B12
    return #B04
  end if
  if getaProp(getaProp(gObjects, #BBallon), #solved) = #true then
    return #B04B
  else
    if getaProp(getaProp(gObjects, #BBallon), #solved) = #false then
      return #B04A
    end if
  end if
end

on calcTransToB07 Test
  if (getaProp(gCurKeyList, #RefName) = #B12A) or (getaProp(gCurKeyList, #RefName) = #B12B) then
    set gKeyRef to #B12
    return #B07
  end if
end

on calcTransToB08 Test
  if Test = #Debug then
    return [#B08A, #B08B]
  end if
  if getaProp(getaProp(gObjects, #BBallon), #solved) = #true then
    return #B08B
  else
    if getaProp(getaProp(gObjects, #BBallon), #solved) = #false then
      return #B08A
    end if
  end if
end

on calcTransToB12 Test
  if Test = #Debug then
    return [#B12A, #B12B]
  end if
  if getaProp(getaProp(gObjects, #BBallon), #solved) = #true then
    return #B12B
  else
    if getaProp(getaProp(gObjects, #BBallon), #solved) = #false then
      return #B12A
    end if
  end if
end

on calcTransToB13 Test
  if Test = #Debug then
    return [#B13A, #B13B]
  end if
  if getaProp(getaProp(gObjects, #BBallon), #solved) = #true then
    return #B13B
  else
    if getaProp(getaProp(gObjects, #BBallon), #solved) = #false then
      return #B13A
    end if
  end if
end

on calcTransToB19 Test
  if Test = #Debug then
    return [#B19A, #B19B]
  end if
  if getaProp(getaProp(gObjects, #BBallon), #solved) = #true then
    return #B19B
  else
    if getaProp(getaProp(gObjects, #BBallon), #solved) = #false then
      return #B19A
    end if
  end if
end

on calcTransToB28 Test
  if Test = #Debug then
    return [#B28A, #B28B, #B28C, #B28D]
  end if
  if getaProp(getaProp(gObjects, #BRocket), #solved) = #false then
    if getaProp(getaProp(gObjects, #BBridge), #State) = #open then
      return #B28B
    else
      if getaProp(getaProp(gObjects, #BBridge), #State) = #close then
        return #B28A
      end if
    end if
  else
    if getaProp(getaProp(gObjects, #BRocket), #solved) = #true then
      if getaProp(getaProp(gObjects, #BBridge), #State) = #open then
        return #B28C
      else
        if getaProp(getaProp(gObjects, #BBridge), #State) = #close then
          return #B28D
        end if
      end if
    end if
  end if
end

on calcTransToB31 Test
  if Test = #Debug then
    return [#B31A, #B31B, #B31C, #B31D]
  end if
  if getaProp(getaProp(gObjects, #BRocket), #solved) = #false then
    if getaProp(getaProp(gObjects, #BBridge), #State) = #open then
      return #B31B
    else
      if getaProp(getaProp(gObjects, #BBridge), #State) = #close then
        return #B31A
      end if
    end if
  else
    if getaProp(getaProp(gObjects, #BRocket), #solved) = #true then
      if getaProp(getaProp(gObjects, #BBridge), #State) = #open then
        return #B31C
      else
        if getaProp(getaProp(gObjects, #BBridge), #State) = #close then
          return #B31D
        end if
      end if
    end if
  end if
end

on calcTransToB30 Test
  if Test = #Debug then
    return [#B30]
  end if
  if getaProp(getaProp(gObjects, #BRocket), #solved) = #false then
    return #B30
  else
    if getaProp(getaProp(gObjects, #BRocket), #solved) = #true then
      return #empty
    end if
  end if
end

on calcTransToB10 Test
  if Test = #Debug then
    return [#B10A, #B10B]
  end if
  if (getaProp(getaProp(gObjects, #BBridge), #State) = #close) and (getaProp(getaProp(gObjects, #BRocket), #solved) = #false) and (getaProp(getaProp(gObjects, #BBallon), #solved) = #false) then
    return #B10A
  else
    return #B10B
  end if
end
